"use strict";

exports.__esModule = true;
exports.createDashboardModule = void 0;
var _hostModules = require("@wix/sdk-runtime/host-modules");
var _sdk = require("./sdk");
const createDashboardModule = ({
  createHost
}) => {
  const dashboardSDKBuilders = (0, _sdk.createSDKBuilders)();
  return {
    ...(0, _hostModules.createHostModule)(dashboardSDKBuilders),
    host: createHost,
    auth: () => {
      return {
        getAuthHeaders: async host => {
          const getAccessToken = dashboardSDKBuilders.getAccessToken(host);
          return {
            headers: {
              Authorization: await getAccessToken()
            }
          };
        }
      };
    }
  };
};
exports.createDashboardModule = createDashboardModule;
//# sourceMappingURL=dashboardHostModule.js.map