"use strict";

exports.__esModule = true;
exports.getEssentialsFromQueryParams = getEssentialsFromQueryParams;
function safeParseEssentials(essentials) {
  if (!essentials) {
    return undefined;
  }
  try {
    return JSON.parse(decodeURIComponent(essentials));
  } catch (e) {
    console.warn('Failed to parse "essentials" query parameter. Make sure to run the code inside a supported Wix App extension.', e);
    return undefined;
  }
}
function getEssentialsFromQueryParams(queryParams) {
  return queryParams.has('essentials') ? safeParseEssentials(queryParams.get('essentials')) : undefined;
}
//# sourceMappingURL=essentials.js.map