import { createHostModule } from '@wix/sdk-runtime/host-modules';
import { createSDKBuilders } from './sdk';
export const createDashboardModule = _ref => {
  let {
    createHost
  } = _ref;
  const dashboardSDKBuilders = createSDKBuilders();
  return {
    ...createHostModule(dashboardSDKBuilders),
    host: createHost,
    auth: () => {
      return {
        getAuthHeaders: async host => {
          const getAccessToken = dashboardSDKBuilders.getAccessToken(host);
          return {
            headers: {
              Authorization: await getAccessToken()
            }
          };
        }
      };
    }
  };
};
//# sourceMappingURL=dashboardHostModule.js.map